include \masm32\MasmBasic\MasmBasic.inc	; download from http://www.masm32.com/board/index.php?topic=12460.0
.686
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 20000/100

.data
SrcA	db 32
	REPEAT 100
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos."
	ENDM
	db "x", 0, "xxxxxxxxx"	; lowercase x
SrcB	db 32
	REPEAT 100
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos."
	ENDM
	db "X", 0, "xxxxxxxxx"	; UPPERCASE X

.code
start:
	push 1			; press Control X to cut code for
	call ShowCpu	; printing brand string and SSE level

	REPEAT 2
	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		test eax, StringsDiffer(offset SrcA, offset SrcB)
	counter_end
	print str$(eax), 9, "cycles for StringsDiffer", 13, 10
	; Print Str$("%i\tcycles for StringsDiffer\n", eax)

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke crt_strcmp, offset SrcA, offset SrcB
		test eax, eax
	counter_end
	print str$(eax), 9, "cycles for crt_strcmp", 13, 10

	counter_begin LOOP_COUNT/5, HIGH_PRIORITY_CLASS
		invoke lstrcmp, offset SrcA, offset SrcB
		test eax, eax
	counter_end
	print str$(eax), 9, "cycles for lstrcmp", 13, 10, 10
	ENDM

	REPEAT 2
	invoke Sleep, 100

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		test eax, StringsDiffer(offset SrcA, offset SrcB, 1)
	counter_end
	print str$(eax), 9, "cycles for StringsDiffer (case-insensitive)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke crt__stricmp, offset SrcA, offset SrcB
		test eax, eax
	counter_end
	print str$(eax), 9, "cycles for crt__stricmp", 13, 10

	counter_begin LOOP_COUNT/5, HIGH_PRIORITY_CLASS
		invoke lstrcmpi, offset SrcA, offset SrcB
		test eax, eax
	counter_end
	print str$(eax), 9, "cycles for lstrcmpi", 13, 10, 10
	ENDM

	Inkey "--- ok ---"
	exit

ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi								; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
OPT_Res	0
